
/*
 *
 *    Copyright  2007 Sun Microsystems, Inc. All rights reserved
 *
 *    Use is subject to license terms.
 *
 */

public class Fibonacci1 implements StressingObject {
    
    int iterations = 0;
    public int result = 0;
    
    /** Creates a new instance of Fibonacci1 */
    public Fibonacci1(int nb_iter) {
        iterations = nb_iter;
    }
    
    /** Default constructor for Fibonacci1 */
    public Fibonacci1() {
        iterations = 1;
    }

    /** recursive computation of Fibonacci(n) */
    private int recursiveFib(int n) {

        // we define Fibonacci serie as :
        // - for n <= 2, Fibonacci(n) = 1;
        // - otherwise Fibonacci(n) = Fibonacci(n-1) + Fibonacci(n-2)
        if (n <= 2) result = 1;
        else  result = (recursiveFib(n-1) + recursiveFib(n-2));
        
        return result;

    }
    
    /** iterates iterations time to calculate recursively Fib(iterations) */
    public int computeFib() {
        int fib = 0;
        for (int i = 1; i < iterations; i++ ) {
            recursiveFib(iterations);
        }
        return fib = recursiveFib(iterations);
    }

    /** StressingObject interface implementation */
    public void stress() {
        int i = computeFib();
    }

    /** StressingObject interface implementation */
    public void setStressClassIterations(int nb_stress_class_iterations) {
        iterations = nb_stress_class_iterations;
    }

}
